Pulp - Story #6205

[Epic] As a user, | have a single container with all Pulp services

02/20/2020 04:26 PM - bmbouter

Status: CLOSED - CURRENTRELEASE Start date:

Priority: Normal Due date:

Assignee: dkliban@redhat.com % Done: 0%
Category: Estimated time: 0:00 hour
Sprint/Milestone:

Platform Release: Tags:

Groomed: Yes Sprint: Sprint 82
Sprint Candidate: Yes Quarter:

Description

Motivation

A Pulp user has a requirement where they want to launch Pulp's in each datacenter to sync content around the world daily. They
specifically can only launch 1 docker container (their requirement). This is because there are too many individuals at various sites

with equipment/networking differences to make deploying multiple containers feasible.

Solution

He proposed that we do what Gitlab does and use a userspace process launcher like s6-overlay to have all the services in that one

container.
What's in the image?

® All GA's plugins would be in the image.
* S6 would start the postgresql and apply the migrations

* Then S6 starts redis, gunicorn (api), gunicorn (content app), nginx, resource manager, and two workers.

Building it

We'll build it nightly on Travis similar to how we build our other containers nightly.

Shipping it
We'll ship it through the pulp account on quay
Advertising it

We should put it on the homepage of https://pulpproject.org/

History

#1 - 02/20/2020 04:28 PM - bmbouter

- Description updated

#2 - 02/20/2020 04:57 PM - daviddavis
- Groomed changed from No to Yes

- Sprint Candidate changed from No to Yes

#3 - 02/21/2020 03:38 PM - ggainey

Don't forget to think about how to handle updates in this single-container case

#4 - 02/21/2020 03:43 PM - bmbouter

ggainey wrote:
https://docs.gitlab.com/omnibus/docker/
https://github.com/just-containers/s6-overlay
https://pulpproject.org/

Don't forget to think about how to handle updates in this single-container case

| was thinking updates will be handled by migrations application, which will happen each time the container is started. It's connected to the long-living
filesystem backing the database and filesystem so each time it's started it can upgrade from the files it finds then.

#5 - 02/21/2020 03:45 PM - mdepaulo@redhat.com
As mentioned on the Mailing list (correction: accidentally replied to Tania individually):

if we do pursue this, we should at least consider using something else with less duplicate code to accomplish this, like our ansible-pulp roles with
ansible-bender, or adapting our existing Cl's ansible-pulp molecule container w/ systemd (normally a temporary artifact.)

Also:

We have the insta-demo already for a dead simple deployment. This use case covers a simple (but less simple) deployment for people with existing
small-scale container infrastructure.

We have to be concerned with postgres & rq also
We have to account for persistent data in volume mount(s). And upgrading it over time.

#5394 Separate out building the pulpcore container image from building a plugin image, and an overall strategy for building container images with
different sets of plugins, is still relevant.

#6 - 02/26/2020 09:19 PM - dkliban@redhat.com
- Status changed from NEW to ASSIGNED
- Assignee set to dkliban@redhat.com

- Sprint set to Sprint 67

#7 - 03/06/2020 04:09 PM - rchan
- Sprint changed from Sprint 67 to Sprint 68

#8 - 03/20/2020 04:21 PM - rchan
- Sprint changed from Sprint 68 to Sprint 69

#9 - 04/03/2020 06:13 PM - rchan
- Sprint changed from Sprint 69 to Sprint 70

#10 - 04/20/2020 02:37 PM - rchan
- Sprint changed from Sprint 70 to Sprint 71

#11 - 05/01/2020 06:00 PM - rchan
- Sprint changed from Sprint 71 to Sprint 72

#12 - 05/15/2020 04:16 PM - rchan
- Sprint changed from Sprint 72 to Sprint 73

#13 - 05/29/2020 02:32 PM - rchan
- Sprint changed from Sprint 73 to Sprint 74

#14 - 06/11/2020 10:27 PM - rchan
- Sprint changed from Sprint 74 to Sprint 75

#15 - 06/26/2020 06:04 PM - rchan
- Sprint changed from Sprint 75 to Sprint 76

#16 - 07/10/2020 08:32 PM - rchan
- Sprint changed from Sprint 76 to Sprint 77

#17 - 07/27/2020 09:27 PM - fao89

| believe we can close this issue
https://github.com/ansible-community/ansible-bender
https://github.com/pulp/ansible-pulp/tree/master/molecule/default
https://github.com/pulp/pulp-operator/tree/master/insta-demo
https://pulp.plan.io/issues/5394

#18 - 07/28/2020 12:06 AM - rchan
- Sprint changed from Sprint 77 to Sprint 78

#19 - 08/07/2020 04:35 PM - rchan
- Sprint changed from Sprint 78 to Sprint 79

#20 - 08/24/2020 01:11 PM - rchan
- Sprint changed from Sprint 79 to Sprint 80

#21 - 09/04/2020 05:25 PM - rchan
- Sprint changed from Sprint 80 to Sprint 81

#22 - 09/18/2020 09:30 PM - rchan
- Sprint changed from Sprint 81 to Sprint 82

#23 - 09/22/2020 09:01 PM - fao89
- Status changed from ASSIGNED to CLOSED - CURRENTRELEASE

it is already delivered - https://github.com/pulp/pulp-oci-images
https://github.com/pulp/pulp-oci-images
http://www.tcpdf.org

